QT       += core gui
QT += network
QT += serialport
QT += serialport network
QT += websockets
QT += widgets
greaterThan(QT_MAJOR_VERSION, 4): QT += widgets


CONFIG += c++11
include(./QsLog/QsLog.pri)
# The following define makes your compiler emit warnings if you use
# any Qt feature that has been marked deprecated (the exact warnings
# depend on your compiler). Please consult the documentation of the
# deprecated API in order to know how to port your code away from it.
DEFINES += QT_DEPRECATED_WARNINGS

# You can also make your code fail to compile if it uses deprecated APIs.
# In order to do so, uncomment the following line.
# You can also select to disable deprecated APIs only up to a certain version of Qt.
#DEFINES += QT_DISABLE_DEPRECATED_BEFORE=0x060000    # disables all the APIs deprecated before Qt 6.0.0

SOURCES += \
    canshupeizhi.cpp \
    keyboard.cpp \
    ledcontrol.cpp \
    main.cpp \
    mainpage_a_v.cpp \
    mainpage_data.cpp \
    mainpage_jfparameter.cpp \
    mainpage_power.cpp \
    mainpage_quality.cpp \
    mainpage_rxy.cpp \
    mainpage_temp.cpp \
    mainwindow.cpp \
    mcu_arm1.cpp \
    module4g.cpp \
    modulepostdata.cpp \
    modulesystime.cpp \
    modulewifi.cpp \
    wangluo.cpp \
    xitongshezhi.cpp \
    keyboard_ABC.cpp \
    uart.cpp \
    uart1.cpp \
    MCU_ARM.cpp \

HEADERS += \
    canshupeizhi.h \
    keyboard.h \
    ledcontrol.h \
    mainpage_a_v.h \
    mainpage_data.h \
    mainpage_jfparameter.h \
    mainpage_power.h \
    mainpage_quality.h \
    mainpage_rxy.h \
    mainpage_temp.h \
    mainwindow.h \
    mcu_arm1.h \
    module4g.h \
    modulepostdata.h \
    modulesystime.h \
    modulewifi.h \
    wangluo.h \
    xitongshezhi.h \
    keyboard_ABC.h \
    uart.h \
    uart1.h \
    MCU_ARM.h \

FORMS += \
    canshupeizhi.ui \
    keyboard.ui \
    mainwindow.ui \
    net_thread.ui \
    wangluo.ui \
    xitongshezhi.ui \
    keyboard_ABC.ui


# Default rules for deployment.
qnx: target.path = /tmp/$${TARGET}/bin
else: unix:!android: target.path = /opt/$${TARGET}/bin
!isEmpty(target.path): INSTALLS += target

win32 {
    LIBS += -lQsLog2
} else {
    LIBS += -lQsLog
}
DISTFILES += \
    C:/Users/Administrator/Desktop/微信截图_20220413180205.png \

RESOURCES += \
    image.qrc
