﻿#ifndef MAINPAGE_QUALITY_H
#define MAINPAGE_QUALITY_H

#include <QWidget>
#include <QLabel>
#include <QPushButton>
#include <uart1.h>
class mainpage_Quality : public QWidget
{
    Q_OBJECT
public:
    explicit mainpage_Quality(QWidget *parent = nullptr);

private:
    QLabel *label_out_of_balance_current;//三相不平衡电流
    QLabel *label_out_of_balance_voltage;//三相不平衡电压
    QLabel *label_A_Voltage_top;//电压幅值
    QLabel *label_B_Voltage_top;
    QLabel *label_C_Voltage_top;
    QLabel *label_A_Voltage_phase;//电压相角
    QLabel *label_B_Voltage_phase;
    QLabel *label_C_Voltage_phase;
    QLabel *label_A_Current_phase;//电流相角
    QLabel *label_B_Current_phase;
    QLabel *label_C_Current_phase;
    QLabel *label_frequency;//频率

    QLabel *label_A_out_of_xiebo_jibian_voltage;//电压谐波畸变
    QLabel *label_B_out_of_xiebo_jibian_voltage;
    QLabel *label_C_out_of_xiebo_jibian_voltage;
    QLabel *label_A_out_of_xiebo_jibian_current;//电流谐波畸变
    QLabel *label_B_out_of_xiebo_jibian_current;
    QLabel *label_C_out_of_xiebo_jibian_current;
    QLabel *label_A_out_of_xiebo_K_voltage;//电压谐波K因子
    QLabel *label_B_out_of_xiebo_K_voltage;
    QLabel *label_C_out_of_xiebo_K_voltage;
    QLabel *label_A_out_of_xiebo_K_current;//电流谐波K因子
    QLabel *label_B_out_of_xiebo_K_current;
    QLabel *label_C_out_of_xiebo_K_current;

    QLabel *label_xiebo_jibian_voltage_titel;
    QLabel *label_xiebo_jibian_current_titel;

    QLabel *label_xiebo_top_voltage_titel;
    QLabel *label_xiebo_top_current_titel;

    QLabel *label_xiebo_K_voltage_titel;
    QLabel *label_xiebo_K_current_titel;

    QLabel *label_A_out_of_xiebo_top_voltage;//电压谐波峰值因子
    QLabel *label_B_out_of_xiebo_top_voltage;
    QLabel *label_C_out_of_xiebo_top_voltage;
    QLabel *label_A_out_of_xiebo_top_current;//电流谐波峰值因子
    QLabel *label_B_out_of_xiebo_top_current;
    QLabel *label_C_out_of_xiebo_top_current;

    QFrame *line_quality_1_1;//电能质量label分割线
    QFrame *line_quality_1_2;
    QFrame *line_quality_1_3;
    QFrame *line_quality_1_4;
    QFrame *line_quality_1_5;
    QFrame *line_quality_2_1;
    QFrame *line_quality_2_2;
    QFrame *line_quality_2_3;
    QFrame *line_quality_2_4;
    QFrame *line_quality_2_5;

    QPushButton *button_quality_1;//电能质量上一页按钮
    QPushButton *button_quality_2;//电能质量下一页按钮
signals:
    void sigPageThreeSend();
private slots:
    void button_quality_1_clicked();//电能质量上一页按钮槽函数
    void button_quality_2_clicked();//电能质量下一页按钮槽函数
    void onPageThreeDataUpdate();
};

#endif // MAINPAGE_QUALITY_H
