#ifndef APPLIVE_H
#define APPLIVE_H

#include <QObject>

class QUdpSocket;
class QTcpSocket;

class AppLive : public QObject
{
	Q_OBJECT

public:
    static AppLive *Instance();
    explicit AppLive(QObject *parent = 0);	
    ~AppLive();

private:
    static QScopedPointer<AppLive> self;
    //QUdpSocket *udpServer;
    QTcpSocket *tcpServer;
    QString appName;

private slots:
    void readData();

public slots:
    bool start(int port);
    void stop();
};

#endif // APPLIVE_H
