﻿#ifndef CANSHUPEIZHI_H
#define CANSHUPEIZHI_H

#include <QWidget>
#include <QLineEdit>
#include <QPushButton>
#include <QLabel>
#include <QComboBox>
#include <keyboard.h>
#include <keyboard_ABC.h>
#include <QFrame>
#include <QPropertyAnimation>
#include <QParallelAnimationGroup>
#include <QDebug>
#include <QMouseEvent>
#include <QFile>

extern bool lowpower_mode_flag1;
extern bool wlpz_flag,xtpz_flag;

extern bool KeyBoard_Code,KeyBoard_ABC_Code,keyBoard_flag,keyBoard_ABC_flag;

static QString line1,line2,line3,line4,line5,line6,line7,line8,line9,line10,line11,line12,line13,line14,line15,line16,line17,line18,line19,line20,line21,line22,line23,line24,line25,line26,line27,line28,line29,line30,line31,line32,line33,line34,line35,line36,line37,line38,line39,line40,line41,line42,line43,line44,line45,line46,line47,line48,line49,line50,line51,line52,line53,line54,line55,line56,line57,line58,line59,line60;
static QString name1,name2,name3,name4,name5,name6,name7,name8,name9,name10,name11,name12,name13,name14,name15,name16,name17,name18,name19,name20,name21,name22,name23,name24,name25,name26,name27,name28,name29,name30,name31,name32,name33,name34,name35,name36,name37,name38,name39,name40,name41,name42,name43,name44,name45,name46,name47,name48,name49,name50,name51,name52,name53,name54,name55,name56,name57,name58,name59,name60;
static QString rxy_time1,rxy_time2,rxy_time3,rxy_time4,rxy_time5,rxy_data1,rxy_data2,rxy_data3,rxy_data4,rxy_data5,rxy_data6;

namespace Ui {
class canshupeizhi;
}

class canshupeizhi : public QWidget
{
    Q_OBJECT

public:
    explicit canshupeizhi(QWidget *parent = nullptr);
    ~canshupeizhi();
    KeyBoard *keyBoard1=nullptr;
    KeyBoard_ABC *keyBoard_ABC1=nullptr;

    QLineEdit *mimaline;
    QPushButton *mimaButton;
    QLabel *label_mima1;
    QLabel *label_mima2;
    QLabel *label_mimajiemian;

    void cspz_set_back_color();
protected:
    bool eventFilter(QObject *watched, QEvent *event);
    void cspz_page(int a);//参数配置显示页数

private slots:
    void label_cspz_0_1_clicked();
    void label_cspz_0_3_clicked();
    void label_cspz_0_5_clicked();
    void label_cspz_0_6_clicked();
    void label_cspz_0_wirenameset_clicked();

    void on_pushButton_zhujiemian_clicked();
    void on_pushButton_wangluoxinxi_clicked();
    void on_pushButton_canshushezhi_clicked();
    void on_pushButton_xitongshezhi_clicked();

    void mimaButtonClicked();

    void callKeyBoard(QLineEdit *a);
    void callKeyBoard_ABC_Can(QLineEdit *a);

    void label_cspz_1_show(int a);
    void label_cspz_3_show(int a);
    void label_cspz_5_show(int a);
    void label_cspz_6_show(int a);
    void label_cspz_0_wirenameset_show(int a);

    void cspz_byqset_page();
    void cspz_rxyset_page();
    void cspz_fengjiset_page();
    void cspz_wireless_adress_set_page();
    void cspz_wireless_name_set_page();

    void button_cspz_1_1_Clicked();
    void button_cspz_3_1_Clicked();
    void button_cspz_3_2_Clicked();
    void button_cspz_rxy1_start_Clicked();
    void button_cspz_rxy2_start_Clicked();
    void button_cspz_5_1_Clicked();
    void button_cspz_5_2_Clicked();
    void button_cspz_5_3_Clicked();
    void button_cspz_5_4_Clicked();
    void button_cspz_5_5_Clicked();
    void button_cspz_6_1_Clicked();
    void button_cspz_6_2_Clicked();
    void button_cspz_6_3_Clicked();
    void button_cspz_6_4_Clicked();
    void button_cspz_wirename_1_Clicked();
    void button_cspz_wirename_2_Clicked();
    void button_cspz_wirename_3_Clicked();
    void button_cspz_wirename_4_Clicked();

    void comboBox_cspz_3_1_IndexChanged(int);//热像仪设备选择
private:
    Ui::canshupeizhi *ui;

    bool cspz_wxcw_down_page_flag=true;
    bool cspz_wxcw_top_page_flag=false;
    bool cspz_wxcw_name_down_page_flag=true;
    bool cspz_wxcw_name_top_page_flag=false;

    QLabel *label_cspz_0_1;//左右滑动切换页面label（变压器参数配置）
    QLabel *label_cspz_0_3;
    QLabel *label_cspz_0_5;
    QLabel *label_cspz_0_6;
    QLabel *label_cspz_0_wirenameset;

    QLabel *label_cspz_byq_back;
    QLabel *label_cspz_rxy_back;
    QLabel *label_cspz_fengji_back;
    QLabel *label_cspz_wuxiancewen_back;
    QLabel *label_cspz_wirenameset_back;

    QLabel *label_cspz_1_1;//变压器参数修改页面label1
    QLabel *label_cspz_1_2;
    QLabel *label_cspz_1_3;
    QLabel *label_cspz_1_4;
    QLabel *label_cspz_1_5;
    QLineEdit *lineEdit_cspz_1_1;
    QLineEdit *lineEdit_cspz_1_2;
    QLineEdit *lineEdit_cspz_1_3;

    QLineEdit *lineEdit_cspz_1_1_A;
    QLineEdit *lineEdit_cspz_1_2_B;
    QLineEdit *lineEdit_cspz_1_3_C;
    QLineEdit *lineEdit_cspz_1_3_T;

    QPushButton *button_cspz_1_1;

    QLabel *label_cspz_3_1;//热像仪参数修改页面label1
    QLabel *label_cspz_3_2;
    QLabel *label_cspz_3_3;
    QLabel *label_cspz_3_4;
    QLabel *label_cspz_3_5;
    QLabel *label_cspz_3_6;//单位
    QLabel *label_cspz_3_7;
    QLabel *label_cspz_3_8;
    QLabel *label_cspz_3_9;
    QLabel *label_cspz_3_10;
    QLabel *label_cspz_3_11;
    QLabel *label_cspz_3_12;
    QLabel *label_cspz_3_13;
    QLabel *label_cspz_3_14;
    QLabel *label_cspz_3_15;//保存提示
    QLabel *label_cspz_3_16;//热像仪IP
    QLabel *label_cspz_3_17;//端口号
    QLabel *label_cspz_3_18;//反射温度
    QLabel *label_cspz_3_19;//℃
    QLabel *label_cspz_3_20;//反射率
    QLabel *label_cspz_3_21;//反射距离
    QLabel *label_cspz_3_22;//米
    QLabel *label_cspz_3_23;//温度预警
    QLabel *label_cspz_3_24;//℃
    QLabel *label_cspz_3_25;//温度报警
    QLabel *label_cspz_3_26;//℃
    QLabel *label_cspz_3_27;//两次报警之间的时间间隔
    QLabel *label_cspz_3_28;//s
    QLabel *label_cspz_3_29;//设备选择
    QLabel *label_cspz_3_30;//分
    QLabel *label_cspz_3_31;//分
    QLineEdit *lineEdit_cspz_3_1;
    QLineEdit *lineEdit_cspz_3_2;
    QLineEdit *lineEdit_cspz_3_3;
    QLineEdit *lineEdit_cspz_3_4;
    QLineEdit *lineEdit_cspz_3_5;
    QLineEdit *lineEdit_cspz_3_6;
    QLineEdit *lineEdit_cspz_3_7;//IP
    QLineEdit *lineEdit_cspz_3_8;//端口号
    QLineEdit *lineEdit_cspz_3_9;//反射温度
    QLineEdit *lineEdit_cspz_3_10;//反射率
    QLineEdit *lineEdit_cspz_3_11;//反射距离
    QLineEdit *lineEdit_cspz_3_12;//温度预警
    QLineEdit *lineEdit_cspz_3_13;//温度报警
    QLineEdit *lineEdit_cspz_3_14;//两次报警之间的时间间隔
    QLineEdit *lineEdit_cspz_3_15;//分钟
    QLineEdit *lineEdit_cspz_3_16;//分钟
    QPushButton *button_cspz_3_1;
    QPushButton *button_cspz_3_2;
    QComboBox *combox_cspz_3_1;
    QFrame *line_cspz_3_1;
    QLabel *label_cspz_rxy1_start;//热像仪1开启状态
    QPushButton *button_cspz_rxy1_start;//热像仪1开启按钮
    QLabel *label_cspz_rxy2_start;//热像仪2开启状态
    QPushButton *button_cspz_rxy2_start;//热像仪2开启按钮

    QLabel *label_cspz_5_1;//风机修改页面label1
    QLabel *label_cspz_5_2;
    QLabel *label_cspz_5_3;
    QLabel *label_cspz_5_4;
    QLabel *label_cspz_5_5;
    QLabel *label_cspz_5_6;
    QLabel *label_cspz_5_7;
    QLabel *label_cspz_5_8;
    QLabel *label_cspz_5_9;
    QLabel *label_cspz_5_10;
    QLabel *label_cspz_5_11;
    QLabel *label_cspz_5_12;
    QLabel *label_cspz_5_13;
    QLabel *label_cspz_5_14;
    QLabel *label_cspz_5_15;
    QLabel *label_cspz_5_18;
    QLabel *label_cspz_5_19;//开启铁芯温度检测
    QLabel *label_cspz_5_20;//开启风机定时检测

    QLineEdit *lineEdit_cspz_5_1;
    QLineEdit *lineEdit_cspz_5_2;
    QLineEdit *lineEdit_cspz_5_3;
    QLineEdit *lineEdit_cspz_5_4;
    QLineEdit *lineEdit_cspz_5_5;
    QLineEdit *lineEdit_cspz_5_6;
    QLineEdit *lineEdit_cspz_5_7;

    QPushButton *button_cspz_5_1;
    QPushButton *button_cspz_5_2;
    QPushButton *button_cspz_5_3;
    QPushButton *button_cspz_5_4;
    QPushButton *button_cspz_5_5;
    QFrame *line_cspz_5_1;

    QLabel *label_cspz_6_1;//无线测温地址修改页面label1
    QLabel *label_cspz_6_2;
    QLabel *label_cspz_6_3;
    QLabel *label_cspz_6_4;
    QLabel *label_cspz_6_5;
    QLabel *label_cspz_6_6;
    QLabel *label_cspz_6_7;
    QLabel *label_cspz_6_8;
    QLabel *label_cspz_6_9;
    QLabel *label_cspz_6_10;
    QLabel *label_cspz_6_11;
    QLabel *label_cspz_6_12;
    QLabel *label_cspz_6_13;
    QLabel *label_cspz_6_14;
    QLabel *label_cspz_6_15;
    QLabel *label_cspz_6_16;
    QLabel *label_cspz_6_17;
    QLabel *label_cspz_6_18;
    QLabel *label_cspz_6_19;
    QLabel *label_cspz_6_20;
    QLabel *label_cspz_6_21;
    QLabel *label_cspz_6_22;
    QLabel *label_cspz_6_23;
    QLabel *label_cspz_6_24;
    QLabel *label_cspz_6_25;
    QLabel *label_cspz_6_26;
    QLabel *label_cspz_6_27;
    QLabel *label_cspz_6_28;
    QLabel *label_cspz_6_29;
    QLabel *label_cspz_6_30;

    QLabel *label_cspz_6_31;//保存成功提示
    QLineEdit *lineEdit_cspz_6_1;
    QLineEdit *lineEdit_cspz_6_2;
    QLineEdit *lineEdit_cspz_6_3;
    QLineEdit *lineEdit_cspz_6_4;
    QLineEdit *lineEdit_cspz_6_5;
    QLineEdit *lineEdit_cspz_6_6;
    QLineEdit *lineEdit_cspz_6_7;
    QLineEdit *lineEdit_cspz_6_8;
    QLineEdit *lineEdit_cspz_6_9;
    QLineEdit *lineEdit_cspz_6_10;
    QLineEdit *lineEdit_cspz_6_11;
    QLineEdit *lineEdit_cspz_6_12;
    QLineEdit *lineEdit_cspz_6_13;
    QLineEdit *lineEdit_cspz_6_14;
    QLineEdit *lineEdit_cspz_6_15;
    QLineEdit *lineEdit_cspz_6_16;
    QLineEdit *lineEdit_cspz_6_17;
    QLineEdit *lineEdit_cspz_6_18;
    QLineEdit *lineEdit_cspz_6_19;
    QLineEdit *lineEdit_cspz_6_20;
    QLineEdit *lineEdit_cspz_6_21;
    QLineEdit *lineEdit_cspz_6_22;
    QLineEdit *lineEdit_cspz_6_23;
    QLineEdit *lineEdit_cspz_6_24;
    QLineEdit *lineEdit_cspz_6_25;
    QLineEdit *lineEdit_cspz_6_26;
    QLineEdit *lineEdit_cspz_6_27;
    QLineEdit *lineEdit_cspz_6_28;
    QLineEdit *lineEdit_cspz_6_29;
    QLineEdit *lineEdit_cspz_6_30;

    QPushButton *button_cspz_6_1;
    QPushButton *button_cspz_6_2;
    QPushButton *button_cspz_6_3;
    QPushButton *button_cspz_6_4;

    QLabel *label_cspz_wirename_1;//无线测温name修改页面
    QLabel *label_cspz_wirename_2;
    QLabel *label_cspz_wirename_3;
    QLabel *label_cspz_wirename_4;
    QLabel *label_cspz_wirename_5;
    QLabel *label_cspz_wirename_6;
    QLabel *label_cspz_wirename_7;
    QLabel *label_cspz_wirename_8;
    QLabel *label_cspz_wirename_9;
    QLabel *label_cspz_wirename_10;
    QLabel *label_cspz_wirename_11;
    QLabel *label_cspz_wirename_12;
    QLabel *label_cspz_wirename_13;
    QLabel *label_cspz_wirename_14;
    QLabel *label_cspz_wirename_15;
    QLabel *label_cspz_wirename_16;
    QLabel *label_cspz_wirename_17;
    QLabel *label_cspz_wirename_18;
    QLabel *label_cspz_wirename_19;
    QLabel *label_cspz_wirename_20;
    QLabel *label_cspz_wirename_21;
    QLabel *label_cspz_wirename_22;
    QLabel *label_cspz_wirename_23;
    QLabel *label_cspz_wirename_24;
    QLabel *label_cspz_wirename_25;
    QLabel *label_cspz_wirename_26;
    QLabel *label_cspz_wirename_27;
    QLabel *label_cspz_wirename_28;
    QLabel *label_cspz_wirename_29;
    QLabel *label_cspz_wirename_30;

    QLabel *label_cspz_wirename_save;//保存成功提示
    QLineEdit *lineEdit_cspz_wirename_1;
    QLineEdit *lineEdit_cspz_wirename_2;
    QLineEdit *lineEdit_cspz_wirename_3;
    QLineEdit *lineEdit_cspz_wirename_4;
    QLineEdit *lineEdit_cspz_wirename_5;
    QLineEdit *lineEdit_cspz_wirename_6;
    QLineEdit *lineEdit_cspz_wirename_7;
    QLineEdit *lineEdit_cspz_wirename_8;
    QLineEdit *lineEdit_cspz_wirename_9;
    QLineEdit *lineEdit_cspz_wirename_10;
    QLineEdit *lineEdit_cspz_wirename_11;
    QLineEdit *lineEdit_cspz_wirename_12;
    QLineEdit *lineEdit_cspz_wirename_13;
    QLineEdit *lineEdit_cspz_wirename_14;
    QLineEdit *lineEdit_cspz_wirename_15;
    QLineEdit *lineEdit_cspz_wirename_16;
    QLineEdit *lineEdit_cspz_wirename_17;
    QLineEdit *lineEdit_cspz_wirename_18;
    QLineEdit *lineEdit_cspz_wirename_19;
    QLineEdit *lineEdit_cspz_wirename_20;
    QLineEdit *lineEdit_cspz_wirename_21;
    QLineEdit *lineEdit_cspz_wirename_22;
    QLineEdit *lineEdit_cspz_wirename_23;
    QLineEdit *lineEdit_cspz_wirename_24;
    QLineEdit *lineEdit_cspz_wirename_25;
    QLineEdit *lineEdit_cspz_wirename_26;
    QLineEdit *lineEdit_cspz_wirename_27;
    QLineEdit *lineEdit_cspz_wirename_28;
    QLineEdit *lineEdit_cspz_wirename_29;
    QLineEdit *lineEdit_cspz_wirename_30;

    QPushButton *button_cspz_wirename_1;
    QPushButton *button_cspz_wirename_2;
    QPushButton *button_cspz_wirename_3;
    QPushButton *button_cspz_wirename_4;
};

#endif // CANSHUPEIZHI_H
